package com.hoge.orm;

import java.util.Collections;
import java.util.List;

import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;

public class PostaldataDAO {
	
	private static final String QUERY = "from Postaldata as p " +
			"where p.zipcode like :zipcode " +
			"and p.pref like :pref " +
			"and p.city like :city " +
			"and p.town like :town order by p.zipcode";
	private static final int MAX_RESULT = 50;
	
	
	public List find(String zipcode, String pref, String city, String town) {
		try {
			Session session = HibernateSessionFactory.getSession();
			Query queryObject = session.createQuery(QUERY);
			
			queryObject.setString("zipcode", zipcode);
			queryObject.setString("pref", pref);
			queryObject.setString("city", city);
			queryObject.setString("town", town);
			
			queryObject.setFirstResult(0);
			queryObject.setMaxResults(MAX_RESULT);
			
			return queryObject.list();
		} catch (HibernateException e) {
			e.printStackTrace();
			return Collections.EMPTY_LIST;
		}
	}

}
